# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section  free
%define cversion 2.0.5

Name:           jsslutils
Summary:        Java SSL Utils
Url:            http://www.eclipse.org/jetty/
Version:        1.0.5
Release:        1%{?dist}
Epoch:          0
License:        Apache Software License 2.0
Group:          Development/Libraries
Source0:        jsslutils-1.0.5.tgz
# svn export http://jsslutils.googlecode.com/svn/tags/release-1.0.5 jsslutils-1.0.5
# tar czf jsslutils-1.0.5.tgz jsslutils-1.0.5/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  apache-commons-parent
BuildRequires:  apache-felix-maven-bundle-plugin
BuildRequires:  tomcat5-server-lib
BuildRequires:  tomcat6
BuildRequires:  tomcat6-lib

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:          java >= 0:1.6.0

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
This project aims to provide a set of utilities regarding 
the use of SSL in Java.
This mainly consists of a set of SSLContextFactory classes 
and a demo CA for testing purposes in the subversion tree.
The original motivation for this library was to provide a 
consistent way of setting SSL-related parameters in Restlet 
and Jetty, in particular for providing more advanced 
features such as support for Certificate Revocation 
Lists (CRLs). 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
cp %{SOURCE1} settings.xml

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.jsslutils jsslutils-root %{version} JPP/%{name} root
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-root.pom

%add_to_maven_depmap org.jsslutils jsslutils-test-certificates %{cversion} JPP/%{name} test-certificates
install -m 644 certificates/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-test-certificates.pom
install -m 644 certificates/target/jsslutils-test-certificates-%{cversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/test-certificates-%{cversion}.jar

%add_to_maven_depmap org.jsslutils jsslutils-extra-apachehttpclient3 %{version} JPP/%{name} apachehttpclient3
install -m 644 extra/apachehttpclient/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-apachehttpclient3.pom
install -m 644 extra/apachehttpclient/target/jsslutils-extra-apachehttpclient3-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/apachehttpclient3-%{version}.jar

%add_to_maven_depmap org.jsslutils jsslutils-extra-apachetomcat5 %{version} JPP/%{name} apachetomcat5
install -m 644 extra/apachetomcat5/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-apachetomcat5.pom
install -m 644 extra/apachetomcat5/target/jsslutils-extra-apachetomcat5-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/apachetomcat5-%{version}.jar

%add_to_maven_depmap org.jsslutils jsslutils-extra-apachetomcat6 %{version} JPP/%{name} apachetomcat6
install -m 644 extra/apachetomcat6/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-apachetomcat6.pom
install -m 644 extra/apachetomcat6/target/jsslutils-extra-apachetomcat6-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/apachetomcat6-%{version}.jar

%add_to_maven_depmap org.jsslutils jsslutils-extra-gsi %{version} JPP/%{name} gsi
install -m 644 extra/gsi/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-gsi.pom
install -m 644 extra/gsi/target/jsslutils-extra-gsi-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/gsi-%{version}.jar

%add_to_maven_depmap org.jsslutils jsslutils %{version} JPP/%{name} jsslutils
install -m 644 jsslutils/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jsslutils.pom
install -m 644 jsslutils/target/jsslutils-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jsslutils-%{version}.jar

%add_to_maven_depmap org.jsslutils jsslutils-test-helpers %{version} JPP/%{name} testhelpers
install -m 644 testhelpers/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-testhelpers.pom
install -m 644 testhelpers/target/jsslutils-test-helpers-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/testhelpers-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{cversion}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{cversion}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/*

%changelog
* Sat Sep 24 2011 Ralph Apel <r.apel at r-apel.de> 0:1.0.5-1
- First release
